/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Weitere Möglichkeiten der Bildbearbeitung mit processing. Als Übungsaufgabe gedacht.
//Um eine Erweiterung durch andere Filter zu ermöglichen, wurden geeignete Klassen angelegt
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
private boolean fertig = false;
protected boolean tasteGedrueckt = false;
protected boolean invertieren = false;
protected boolean schwellenW = false;
protected boolean korrektur = true;
protected PImage  bildOriginal, bildFertig;// bildAusgewaehlt; 
private int[][] tempMatrix, tempInvertMatrix; 
private int[][] bearbeitetMatrix ;
protected int h,w,W,H, wahl;
protected int g = 1; //Stärke des Gaußfilters
private int d = 0; //Verschiebung von bildTrans in x und -y Richtung
private float werte = 2.2;//2.2;//Werte-Verschiebung im Histogramm, wobei schwarz schwarz bleibt
protected float faktor =1;//Geeignet, um bei scharfzeichnen oder Relief das Bild heller(faktor <2) oder dunkler zu machen
private float saettigungFaktor = 0;

Gauss blur;
BlendingFilter subraktion;
MatrixCutter cutLU, cutRO;
EinfachFilter filter;
Scharr edgeScharr;
Sobel edgeSobel;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void setup(){  
    size(800,600);
    w = width;
    h = height;
    background(0);
    colorMode(RGB,255,255,255);
    textSize(16);
    text("Filter-Tool", 40, 40); 
    text("Verwenden Sie die Tasten:", 40, 100); 
    text("<1> für das Schärfen des Bildes (unscharf maskieren).",40, 140);  
    text("<2> für die Verwandlung des Bildes in ein Relief.",40,180);
    text("<3> für die Aufhellung des Bildes - aber schwarz bleibt schwarz.", 40,220);
    text("<4> für die Anwendung des Gaußfilters, um schonend weichzuzeichnen ", 40, 260);   
    text("<5> für die Verstärkung der Farben.", 40, 300); 
    text("<6> für das Extrahieren der Kanten mit Scharr. ", 40, 340); 
    text("<7> für das Extrahieren der Kanten mit Sobel. ", 40, 380); 
    text("<s> für ein Schwellenwert Bild bei <6>.", 40, 420);
    text("Ist das zu bearbeitende Bild größer als size(800,600), dann wird nur ein Teil des Bildes gezeigt...", 40, 460); 
    text("...bearbeitet wird aber das ganze Bild. Zu finden ist es im Programmordner. Bezeichnung: bildBearbeitet.jpg",40,500);
    text("Bei sehr großen Bildern kann der Relieffilter(2) 1-2 Minuten dauern, denn es wird sehr, sehr viel gerechnet!",40,540);  
    
}
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
void draw() {
  if(tasteGedrueckt == true){
    switch(wahl){
     case 1: 
      bildFertig =bildScharfzeichnen(bildOriginal);
      break;
    case 2: 
      bildFertig = bildRelief(bildOriginal);
      break;
    case 3: 
      bildFertig = bildSpreizen(bildOriginal);
      break;
    case 4: 
      bildFertig = bildWeichzeichnen(bildOriginal);
      break;
    case 5:
      bildFertig = bildSaettigung(bildOriginal);
      break;
    case 6:
      bildFertig = bildKantenScharr(bildOriginal);
      break;
    case 7:
      bildFertig = bildKantenSobel(bildOriginal);
      break;
   }
  }
  if(fertig){ 
    //Längere Seite des Bildes wird auf auf 800 Pixel angezeigt  
    //Verbleibende Seite proportional vergrößert/verkleinert
    background(255);
    image(bildFertig,0,0,W,H);   
     bildFertig.save("bildBearbeitet.jpg");
    //saveFrame("bildBearbeitet###.jpg");
    fertig = false;
  }
}
///////////////////////////////////////////////////////////////////////
void keyPressed() {
  
  if (key == '1') {//Bild schärfen    
      g=1; d=0; wahl = 1;
      faktor = 2;
      invertieren = false;
      bildWaehlen();
  } 
  if (key == '2') {//Relief     
     d=2;faktor = 1.4;//faktor = 2;
     g = 1;  wahl =2;  
     invertieren = false;
     bildWaehlen();
  }
  if (key == '3') {//Bild aufellen  
     d=0;
     g = 0; werte = 1.2;//g=0;werte=1.2;
     wahl =3;
     invertieren = false;
     bildWaehlen() ;
  }
   if (key == '4') {//Bild Gauß weichzeichnen 
     d=0;
     g = 1; werte = 1;
     wahl =4;
     invertieren = false;
     bildWaehlen();
   }
   if (key == '5') {//Bild Sättigung erhöhen
     d=0;
     g = 0; werte = 1;
     wahl =5;
     saettigungFaktor = 1.3;
     invertieren = false;
     bildWaehlen();
   }
    if (key == '6') {//Bild Kanten finden Scharr
     wahl =6; 
     korrektur = true;
     invertieren = true;
     schwellenW= true;
     bildWaehlen();
   }
   if (key == '7') {//Bild Kanten finden Sobel
     wahl =7; 
     korrektur = true;
     invertieren = false;
     schwellenW=false;
     bildWaehlen();
   }
    
   if (key == 'k'){
       korrektur = !korrektur;
        bildWaehlen();
       
   }
   if (key == 'i'){
       invertieren = !invertieren;
        bildWaehlen();
   }   
   if (key == 's'){
     schwellenW = ! schwellenW;
      bildWaehlen();
   }
}

/////////////////////////////////////////////////////////////////////// 
//Die folgenden beiden Methoden bewirken, dass ein Lade-Dialog erscheint  
////////////////////////////////////////////////////////////////////////      
 void bildWaehlen(){
      selectInput("", "bildAusgewaehlt");
        while (bildOriginal == null) {
        delay(200);
      }
      loop();
      W =bildOriginal.width; H = bildOriginal.height  ;    
      tasteGedrueckt = true;
 }
///////////////////////////////////////////////////////////////////////////// 
  void bildAusgewaehlt(File auswahl)
    {
      bildOriginal = loadImage(auswahl.getAbsolutePath());
    }
/////////////////////////////////////////////////////////////////////
//Funktion, die ein Pixelbild in eine Matrix verwandelt
 public int[][] matrixVonBild(PImage bildEingabe){  
  PImage bild = bildEingabe; 
  bearbeitetMatrix = new int[H][W]; //println(H,W);
  for(int i = 0; i < W ;i++){
     for(int j = 0; j < H; j++){
       bearbeitetMatrix[j][i] = bild.pixels[i + j*W];
    } 
 }
 return bearbeitetMatrix;
}
////////////////////////////////////////////////////////////////////////
//Matrix in Bild verwandeln
public PImage bildVonMatrix(int[][] matrix){
  
     int[][] bearbeitetMatrix = matrix;
  // int spalten =bearbeitetMatrix[0].length ;
  // int zeilen = bearbeitetMatrix.length;println(zeilen,spalten);
   PImage bild = createImage(W,H,RGB); 
    if(wahl==2){
      for(int i = 0; i < W-2; i++){
         for(int j = 0; j < H-2; j++){   
            bild.pixels[i + j*W] = bearbeitetMatrix[j][i];
         } 
      }
    }else{
       for(int i = 0; i < W; i++){
         for(int j = 0; j < H; j++){   
            bild.pixels[i + j*W] = bearbeitetMatrix[j][i];
         } 
      }
    }
 return bild;
}
/////////////////////////////////////////////////////////////////////
//Weichzeichnen mit 7x7 Gaußmatrix
public PImage bildWeichzeichnen(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Gauß-Weichzeichnen 
   int[][] bearbeitetMatrix = new int[H][W];  
    tempMatrix = new int[H][W]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    blur   = new Gauss(bearbeitetMatrix);
    bearbeitetMatrix = blur.gaussAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true;  
    return bildBearbeitet;   
 }

////////////////////////////////////////////////////////////////////////////////
//"Werte" werden angehoben. Heller machen und trotzdem schwarz erhalten
///////////////////////////////////////////////////////////////////////////////
public PImage bildSpreizen(PImage bild){
    bildOriginal = bild;
    filter = new EinfachFilter(bildOriginal);
    PImage bildBearbeitet = filter.bildSpreizen();
     tasteGedrueckt = false;
    fertig = true;   
    
    return bildBearbeitet;
 }
 
///////////////////////////////////////////////////////////////////////////////// 
//Scharfzeichnen durch "unscharf maskieren"
public PImage bildScharfzeichnen(PImage bild) {
    PImage originalBild = bild;
    PImage bildBearbeitet;
    PImage bildKopie = originalBild.copy();  
    PImage bildBlur = createImage(w,h,RGB);
    bildBlur = bildWeichzeichnen(bildKopie);
    int[][]blurMatrix = matrixVonBild(bildBlur);
    int[][]tempMatrix = matrixVonBild(bild);
    subraktion = new BlendingFilter(blurMatrix, tempMatrix);
    bildBearbeitet = bildVonMatrix(subraktion.matrixBlending());   
    tasteGedrueckt = false;
    fertig = true;   
    
    return bildBearbeitet;
}

/////////////////////////////////////////////////////////////////////////// 
//Unscharfe Kopie herstellen, verschieben und dann  Originalbild blending durch Subraktioen
public PImage bildRelief(PImage bild){
    //Ist d>0 müssen die Bilder für das Blending ausgeschnitten werden
    int[][] blurCutM = new int[H-d][W-d];
    int[][] tempCutM = new int[H-d][W-d];
    PImage bildOriginal = bild;
    PImage bildBearbeitet = createImage(w-d,h-d,RGB);
    PImage bildBlur = createImage(w,h,RGB); 
    bildBlur = bildWeichzeichnen(bildOriginal);
    int[][] blurMatrix = matrixVonBild(bildBlur);
    int[][] tempMatrix = matrixVonBild(bildOriginal);  
    cutLU = new MatrixCutter(blurMatrix,d);
    blurCutM = cutLU.cutMatrixLU();
    cutRO = new MatrixCutter(tempMatrix,d);
    tempCutM = cutRO.cutMatrixRO();
    subraktion = new BlendingFilter(blurCutM, tempCutM);
    bildBearbeitet = bildVonMatrix(subraktion.matrixBlending());
    tasteGedrueckt = false;
    fertig = true;    
    
    return bildBearbeitet;
} 

//////////////////////////////////////////////////////////////////////////////////// 
//Farbmodell HSB nutzen, um auf einfache Weise die Sättigung anzuheben.
public PImage bildSaettigung (PImage bild){
    bildOriginal = bild;
    filter = new EinfachFilter(bildOriginal);
    PImage bildBearbeitet= filter.bildSaettigung();
    tasteGedrueckt = false;
    fertig = true; 
    
    return bildBearbeitet;
}
////////////////////////////////////////////////////////////////////////////////////// 
 
 /////////////////////////////////////////////////////////////////////
//Kanten finden mit Scharr und zwei Matrizen
public PImage bildKantenScharr(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Kanten finden
   int[][] bearbeitetMatrix = new int[h][w];  
    tempInvertMatrix = new int[H][W];
    tempMatrix = new int[H][W]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    edgeScharr   = new Scharr(bearbeitetMatrix);
    bearbeitetMatrix = edgeScharr.ScharrAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true; 
    schwellenW =false;
    return bildBearbeitet;   
 }
 //Kanten finden mit Scharr und zwei Matrizen
public PImage bildKantenSobel(PImage bild) {
    //Fenster verkleinern für kleine Bildschirme
    PImage bildBearbeitet = createImage(w,h,RGB);;
    bildOriginal = bild;
    //1.Bild Kanten finden
   int[][] bearbeitetMatrix = new int[h][w];  
    tempInvertMatrix = new int[H][W];
    tempMatrix = new int[H][W]; 
    bearbeitetMatrix = matrixVonBild(bildOriginal);
    edgeSobel   = new Sobel(bearbeitetMatrix);
    bearbeitetMatrix = edgeSobel.SobelAufMatrixAnwenden();
    bildBearbeitet=  bildVonMatrix(bearbeitetMatrix);    
    tasteGedrueckt = false;
    fertig = true; 
    return bildBearbeitet;   
 }
 
 
 
 
 
 
