/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Die Sobel-Klasse bedient sich zum Kanten finden der unten angegebenen 3x3-Gauß-Faltungsmatrizen
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

public class Sobel{
  
  
  private float[][] gMatrixX = {{1,   0,   -1}, 
                               { 2,   0,   -2}, 
                               { 1,   0,   -1}};  //x-Richtung
                               
  private  float[][] gMatrixY = {{ 1,   2,  1 }, 
                                {  0,   0,   0}, 
                                { -1,  -2,  -1}};  //y-Richtung
  
   private float grauWert;
   private int[][] matrix;
   private int[][] rMatrix ;
   private int[][] tempMatrix;
   private int I,J;
   private int warenSchwarz=0;
   private int weg0 =0;
   private int weg_45 =0;
   private int weg45 = 0;
   private int weg90 =0;
   private float winkel;
   private float winkelEffektiv;
  //Konstruktor
   public Sobel(int[][] matrix){
     this.matrix = matrix;
   }
   
/////////////////////////////////////////////////////////////////////
//Sobel-Filter auf Matrix eines Bildes anwenden
int[][] SobelAufMatrixAnwenden(){
   int[][]  bearbeitetMatrix =  matrix; 
    rMatrix = new int[H][W];
    tempMatrix = new int[H][W];
  
   float grauWertX,grauWertY,richtungsWert;println(W,H);
   for (int i = 0; i < W; i++) { 
      for (int j = 0; j < H; j++) { 
         grauWertX   = 0.0; grauWertY   = 0.0; richtungsWert = 0.0;
         
         for (int kx = -1; kx <= 1; kx++) {
             for (int ky = -1; ky <= 1; ky++) { //Anwendung der Faltungsmatrix bluf 7x7 
               if(i+kx<W && -1<i+kx && j+ky<H && -1<j+ky){
                color c = color(bearbeitetMatrix[j+ky][i+kx]);
                grauWertX+= brightness(c) *gMatrixX[ky+1][kx+1]*1.001 ; //1.001 gleicht die                   
                grauWertY+= brightness(c) *gMatrixY[ky+1][kx+1]*1.001 ; //1.001 gleicht die                                                    
               } // end of if              
            }//end of for ky
        }//end of for kx       
         //grauWertX und grauWertY können negativ sein!
         grauWert = sqrt(sq(grauWertX)+sq(grauWertY));  //Durch sq() beide Summanden positiv
         
         if(grauWertY == 0 && grauWertX == 0){
           winkel = 1000 ; //Markierung für keine Richtung!
           winkelEffektiv = 1000;
         }else{
           richtungsWert = atan(grauWertY/grauWertX);  //Hier ist das Vorzeichen wichtig!        
           winkel = richtungsWert*180/PI;
         }
         if((winkel <= 90 && winkel > 67.5) || winkel< -67.5) winkelEffektiv =90;
         else if( winkel <= 67.5 && winkel > 22.5) winkelEffektiv = 45;
         else if( winkel <= 22.5 && winkel > -22.5) winkelEffektiv = 0;
         else if(winkel <= -22.5 && winkel >= -67.5) winkelEffektiv = -45;
         tempMatrix[j][i] = color(grauWert);        
         rMatrix[j][i] =(int) winkelEffektiv;//90, 45, 0, -45 (1000 nicht definiert)
       
      }//end of for j
   }//end of for i
if(korrektur){ 
   for (int i = 1; i < W-1; i++) {
       for (int j = 1; j < H-1; j++) {
          if(rMatrix[j][i]== 90){
           if(grau(tempMatrix[j][i]) == 0) warenSchwarz++;
            else if(grau(tempMatrix[j+1][i]) > grau(tempMatrix[j][i])
               || grau(tempMatrix[j-1][i]) > grau(tempMatrix[j][i])) {
               tempMatrix[j][i]=0; weg90++;
            }
          } else if(rMatrix[j][i]== 0){
            if(grau(tempMatrix[j][i]) == 0)warenSchwarz++;
             else if(grau(tempMatrix[j][i-1]) > grau(tempMatrix[j][i])
               || grau(tempMatrix[j][i+1]) > grau(tempMatrix[j][i])) {
               tempMatrix[j][i]=0;weg0++;
            }
         } else if(rMatrix[j][i]== 45){
            if(grau(tempMatrix[j][i]) == 0)warenSchwarz++;
             else if(grau(tempMatrix[j+1][i-1]) > grau(tempMatrix[j][i])
               || grau(tempMatrix[j-1][i+1]) > grau(tempMatrix[j][i])) {
               tempMatrix[j][i]=0; weg45++;
            }
         }  else if(rMatrix[j][i]== -45){
            if(grau(tempMatrix[j][i]) == 0)warenSchwarz++;
             else if(grau(tempMatrix[j-1][i-1]) > grau(tempMatrix[j][i])
               || grau(tempMatrix[j+1][i+1]) > grau(tempMatrix[j][i])) {
               tempMatrix[j][i]=0;weg_45++;
            }
          }   
        
       }//end of for j
     }//end of for i   
     
    println(weg90,weg0,weg_45,weg45,weg90+weg0+weg_45+weg45,warenSchwarz); 
 }
   for (int i = 0; i < W; i++) {
     for (int j = 0; j < H; j++) {      
        if(invertieren){
          float gW = grau( tempMatrix[j][i]);
          float gIW = abs(gW-255);
          tempInvertMatrix[j][i] = color(gIW);
          if(schwellenW){
            if(gIW<50) tempInvertMatrix[j][i] = color(0);
            else tempInvertMatrix[j][i] = color(255);
          }else tempInvertMatrix[j][i] = color(gIW);
          bearbeitetMatrix[j][i] =(int) tempInvertMatrix[j][i];
       }else bearbeitetMatrix[j][i] =(int) tempMatrix[j][i];        
     }//end of for j
   }//end of for i  

//Falls die Werte ausgegeben werden sollen  
/* for(int j=0; j<H;j++){
  println();
    for(int i=0; i<W;i++){
       print(rMatrix[j][i]+ " ;"); 
     // print((int)grau(tempMatrix[j][i])+ " ;"); 
       
    }
  }  */
  
  return bearbeitetMatrix ; 
 }
///////////////////////////////////////////////////////////////////////////
float grau(color f){//bestimmt Helligkeit (Grauwert) von f
  float g = brightness(f);
  return g; 
}

  
}
